#include <stdio.h>
#include <SDL/SDL.h>

void print (int key)
{
  int code = -1;
  int extended = 0;

  switch (key) {
    case SDLK_ESCAPE: /* 27 */
      code = 1;
      break;

    case SDLK_1: /* 49 */
    case SDLK_2: /* 50 */
    case SDLK_3: /* 51 */
    case SDLK_4: /* 52 */
    case SDLK_5: /* 53 */
    case SDLK_6: /* 54 */
    case SDLK_7: /* 55 */
    case SDLK_8: /* 56 */
    case SDLK_9: /* 57 */
      code = key - 49 + 2;
      break;

    case SDLK_0: /* 48 */
      code = 11;
      break;

    case SDLK_MINUS: /* 45 */
      code = 12;
      break;

    case SDLK_PLUS: /* 43 */
      code = 13;
      break;

    case SDLK_BACKSPACE: /* 8 */
      code = 14;
      break;

    case SDLK_TAB: /* 9 */
      code = 15;
      break;

    case SDLK_q: /* 113 */
      code = 16;
      break;

    case SDLK_w: /* 119 */
      code = 17;
      break;

    case SDLK_e: /* 101 */
      code = 18;
      break;

    case SDLK_r: /* 114 */
      code = 19;
      break;

    case SDLK_t: /* 116 */
      code = 20;
      break;

    case SDLK_y: /* 121 */
      code = 21;
      break;

    case SDLK_u: /* 117 */
      code = 22;
      break;

    case SDLK_i: /* 105 */
      code = 23;
      break;

    case SDLK_o: /* 111 */
      code = 24;
      break;

    case SDLK_p: /* 112 */
      code = 25;
      break;

    case SDLK_LEFTBRACKET: /* 91 */
      code = 26;
      break;

    case SDLK_RIGHTBRACKET: /* 91 */
      code = 27;
      break;

    case SDLK_RETURN: /* 13 */
      code = 28;
      break;

    case SDLK_LCTRL: /* 306 */
      code = 29;
      break;

    case SDLK_a: /* 97 */
      code = 30;
      break;

    case SDLK_s: /* 115 */
      code = 31;
      break;

    case SDLK_d: /* 100 */
      code = 32;
      break;

    case SDLK_f: /* 102 */
    case SDLK_g: /* 103 */
    case SDLK_h: /* 104 */
      code = key - 102 + 33;
      break;

    case SDLK_j: /* 106 */
    case SDLK_k: /* 107 */
    case SDLK_l: /* 108 */
      code = key - 106 + 36;
      break;

    case SDLK_SEMICOLON: /* 59 */
      code = 39;
      break;

    case SDLK_QUOTE: /* 39 */
      code = 40;
      break;

    case SDLK_BACKQUOTE: /* 96 */
      code = 41;
      break;

    case SDLK_LSHIFT: /* 304 */
      code = 42;
      break;

    case SDLK_z: /* 122 */
      code = 44;
      break;

    case SDLK_x: /* 120 */
      code = 45;
      break;

    case SDLK_c: /* 99 */
      code = 46;
      break;

    case SDLK_v: /* 118 */
      code = 47;
      break;

    case SDLK_b: /* 98 */
      code = 48;
      break;

    case SDLK_n: /* 110 */
      code = 49;
      break;

    case SDLK_m: /* 109 */
      code = 50;
      break;

    case SDLK_COMMA: /* 44 */
      code = 51;
      break;

    case SDLK_PERIOD: /* 46 */
      code = 52;
      break;

    case SDLK_SLASH: /* 47 */
      code = 53;
      break;

    case SDLK_RSHIFT: /* 303 */
      code = 54;
      break;

    case SDLK_KP_MULTIPLY: /* 268 */
      code = 55;
      break;

    case SDLK_LALT: /* 308 */
      code = 56;
      break;

    case SDLK_SPACE: /* 32 */
      code = 57;
      break;

    case SDLK_CAPSLOCK: /* 301 */
      code = 58;
      break;

    case SDLK_F1: /* 282 */
    case SDLK_F2: /* 283 */
    case SDLK_F3: /* 284 */
    case SDLK_F4: /* 285 */
    case SDLK_F5: /* 286 */
    case SDLK_F6: /* 287 */
    case SDLK_F7: /* 288 */
    case SDLK_F8: /* 289 */
    case SDLK_F9: /* 290 */
    case SDLK_F10: /* 291 */
      code = key - 282 + 59;
      break;

    case SDLK_NUMLOCK: /* 300 */
      code = 69;
      break;

    case SDLK_SCROLLOCK: /* 302 */
      code = 70;
      break;

    case SDLK_KP7: /* 263 */
      code = 71;
      break;

    case SDLK_KP8: /* 264 */
      code = 72;
      break;

    case SDLK_KP9: /* 265 */
      code = 73;
      break;

    case SDLK_KP_MINUS: /* 269 */
      code = 75;
      break;

    case SDLK_KP4: /* 260 */
      code = 76;
      break;

    case SDLK_KP5: /* 261 */
      code = 77;
      break;

    case SDLK_KP6: /* 262 */
      code = 77;
      break;

    case SDLK_KP_PLUS: /* 270 */
      code = 78;
      break;

    case SDLK_KP1: /* 257 */
      code = 79;
      break;

    case SDLK_KP2: /* 258 */
      code = 80;
      break;

    case SDLK_KP3: /* 259 */
      code = 81;
      break;

    case SDLK_KP0: /* 256 */
      code = 82;
      break;

    case SDLK_KP_PERIOD: /* 266 */
      code = 83;
      break;

    case SDLK_F11: /* 292 */
      code = 87;
      break;

    case SDLK_F12: /* 293 */
      code = 88;
      break;

      /* EXTENDED */
    case SDLK_KP_ENTER: /* 271 */
      extended = 1;
      code = 28;
      break;

    case SDLK_RCTRL: /* 305 */
      extended = 1;
      code = 29;
      break;

    case SDLK_PRINT: /* 316 */
      extended = 1;
      code = 42;
      break;

    case SDLK_KP_DIVIDE: /* 267 */
      extended = 1;
      code = 53;
      break;

    case SDLK_RALT: /* 307 */
      extended = 1;
      code = 56;
      break;

    case SDLK_HOME: /* 278 */
      extended = 1;
      code = 71;
      break;

    case SDLK_UP: /* 273 */
      extended = 1;
      code = 72;
      break;

    case SDLK_PAGEUP: /* 280 */
      extended = 1;
      code = 73;
      break;

    case SDLK_LEFT: /* 276 */
      extended = 1;
      code = 75;
      break;

    case SDLK_RIGHT: /* 275 */
      extended = 1;
      code = 77;
      break;

    case SDLK_END: /* 279 */
      extended = 1;
      code = 79;
      break;

    case SDLK_DOWN: /* 274 */
      extended = 1;
      code = 80;
      break;

    case SDLK_PAGEDOWN: /* 281 */
      extended = 1;
      code = 81;
      break;

    case SDLK_INSERT: /* 277 */
      extended = 1;
      code = 82;
      break;

    case SDLK_DELETE: /* 127 */
      extended = 1;
      code = 83;
      break;

    default:
      /* printf ("d\n", key); */
      break;
  }
  printf ("%s\t, %x, %x, %d\n", SDL_GetKeyName (key), key, code, extended);
}

int main ()
{
  int i;

  SDL_Init (SDL_INIT_VIDEO);
  for (i = 0; i < 323; i++) {
    print (i);
  }
}
