open Format

let list =
  let ic = stdin in
  let lno = ref 0 in
  let rec fold accu =
    incr lno;
    Printf.fprintf stderr "line %d\n" !lno;
    let l, stop =
      try
        let line = input_line ic in
        line, false
      with End_of_file -> "", true
    in
    if stop then accu
    else
      let tup =
        Scanf.sscanf l "%s@\t\t, %x, %x, %d"
          (fun s n ascii extended ->
            (s, n, ascii, extended))
      in
      fold (tup :: accu)
  in
  fold []

let assoc =
  let len = List.length list in
  let arr = Array.create len ("", 0, 0) in
  List.iter (fun (s, n, ascii, extended) ->
    arr.(n) <- (s, ascii, extended)) list;
  for i = 0 to pred len do
    let (s, ascii, extended) = arr.(i) in
    if ascii != -1 then
      printf "/* %s */%#x,\n" s (ascii lor (if extended != 0 then 0xe000 else 0))
    else
      printf "0xffff,\n"
  done;
  printf "\n"
