#include <inc/int.h>
#include <inc/mem.h>
#include <inc/log.h>
#include <inc/mup.h>

#define LOG_PREFIX "I1A"
static int log_level = -2;

void I1A (INT_ARGS)
{
  if (-2 == log_level)
    log_level = MUP_get_log_level ("i1a");

  switch (AH (r)) {
    case 0x00:
      SET_CX (r, MEM_TICKS >> 16);
      SET_DX (r, MEM_TICKS);
      break;

    case 0xb1:
      switch (AL (r)) {
        case 0x01:
          lwarn ("no handler for %#x\n", AX (r));
          break;
      }
  }
}
