MODDIR=$(I86)
MODSRC+=op.c
MODDEP+=$(BLD)/iconvert.d

ICONVSRC=types.ml reg.ml zz.ml utils.ml pp.ml iconvert.ml
ICONVOBJ=$(ICONVSRC:.ml=.cmo)
ICONVLIBS=str.cma
ICONV=$(I86)/iconvert

include $(BOX)/modules.common

$(I86)/opdbg.c: $(I86)/eff.tab $(I86)/opcod.tab
	$(ICONV) -d $(I86) $(ICONVFLAGS) > $@

$(I86)/opopt.c: $(I86)/eff.tab $(I86)/opcod.tab
	$(ICONV) -d $(I86) $(ICONVFLAGS) > $@

$(I86)/opdbg.c: ICONVFLAGS=-fprintf_debug -ecc -ereg -confirm

ifdef have_ocaml
$(I86)/opopt.c: $(ICONV)
$(I86)/opdbg.c: $(ICONV)
endif

$(OPTDIR)/op.o: CFLAGS.OPT = $(TURTLE.OPT)
$(BLD)/%/op.o: $(MODDIR)/op%.c
	$(CCOMPILE.CMD)

$(BLD)/iconvert.d:
	sh $(TOP)/camldep.sh $(CAMLDEP) -I $(I86) $(I86)/*.ml $(I86)/*.mli >$@

$(I86)/%.cmo $(I86)/%.cmi: $(I86)/%.ml
	$(CAMLC) -I $(<D) -c $<

$(ICONV): $(addprefix $(I86)/,$(ICONVOBJ))
	$(CAMLC) -o $@ $(ICONVLIBS) $^

ICONV.CLEAN=$(addprefix $(I86)/,$(ICONVOBJ) $(ICONV))

clean::
	rm -f $(ICONV.CLEAN) $(DBGDIR)/op.o
ifdef have_ocaml
	rm -f $(I86)/opdbg.c
endif

clean.opt::
	rm -f $(ICONV.CLEAN) $(OPTDIR)/op.o
ifdef have_ocaml
	rm -f $(I86)/opopt.c
endif

distfiles=$(ICONVSRC) module.mak asm.h turtle.h rwdefs.h strops.h \
	opcod.tab eff.tab opdbg.c opopt.c
DISTFILES:=$(DISTFILES) $(addprefix $(MODDIR)/,$(distfiles))
