#define xglue(x,y) turtle_ ## x ## y
#define glue(x,y) xglue(x,y)

#if SIZE == 8
#define D_TYPE uint8_t
#elif SIZE == 16
#define D_TYPE uint16_t
#elif SIZE == 32
#define D_TYPE uint32_t
#elif SIZE == 64
#define D_TYPE uint64_t
#else
#error Bad SIZE
#endif

#if SIZE <= 32
extern D_TYPE glue(read_port, SIZE) AP1__(uint16_t nport);
extern void glue(write_port, SIZE) AP2__(uint16_t nport, D_TYPE val);
#endif

extern D_TYPE glue(read_flat_mem, SIZE) AP1__(uint32_t addr);
extern void glue(write_flat_mem, SIZE) AP2__(uint32_t addr, D_TYPE val);
extern D_TYPE glue(read_mem, SIZE) AP1__(uint32_t ea);
extern D_TYPE glue(read_seg_mem, SIZE) AP2__(int seg, uint32_t ea);
extern void glue(write_mem, SIZE) AP2__(uint32_t ea, D_TYPE val);
extern void glue(write_seg_mem, SIZE) AP3__(int seg, uint32_t ea, D_TYPE val);

#undef D_TYPE
#undef glue
#undef xglue
