#ifndef __AUD_MOO__
#define __AUD_MOO__

#include <inc/adb.h>

typedef enum {
  AUD_FMT_U8,
  AUD_FMT_S8,
  AUD_FMT_U16,
  AUD_FMT_S16
} audfmt_e;

typedef enum {
  AUD_EMU_NONE,
  AUD_EMU_GUS,
  AUD_EMU_SB16
} audemu_e;

extern void     AUD_pre_init (void);
extern void     AUD_init (void);
extern void     AUD_open (int freq, int nchannels, audfmt_e fmt);
extern void     AUD_reset (int rfreq, int rnchannels, audfmt_e rfmt);
extern int      AUD_get_live (void);
extern int      AUD_get_free (void);
extern int      AUD_get_buffer_size (void);
extern int      AUD_write (void *data, int size);
extern void     AUD_run (void);
extern void     AUD_adjust_estimate (int _leftover);
extern audemu_e AUD_get_emu_type (void);

#endif /* __AUD_MOO__ */
