#ifndef __DPMI_MOO__
#define __DPMI_MOO__

#include <inc/adb.h>

struct DPMI_callback {
  us proc_sel;
  ui proc_off;
  us data_sel;
  ui data_off;
  int used;
};

#define DPMI_EDI(r)  *((ui*)((r)+0x00))
#define DPMI_ESI(r)  *((ui*)((r)+0x04))
#define DPMI_EBP(r)  *((ui*)((r)+0x08))
#define DPMI_RSV(r)  *((ui*)((r)+0x0C))
#define DPMI_EBX(r)  *((ui*)((r)+0x10))
#define DPMI_EDX(r)  *((ui*)((r)+0x14))
#define DPMI_ECX(r)  *((ui*)((r)+0x18))
#define DPMI_EAX(r)  *((ui*)((r)+0x1C))
#define DPMI_CFL(r)  *((us*)((r)+0x20))
#define DPMI_ES(r)   *((us*)((r)+0x22))
#define DPMI_DS(r)   *((us*)((r)+0x24))
#define DPMI_FS(r)   *((us*)((r)+0x26))
#define DPMI_GS(r)   *((us*)((r)+0x28))
#define DPMI_IP(r)   *((us*)((r)+0x2A))
#define DPMI_CS(r)   *((us*)((r)+0x2C))
#define DPMI_SP(r)   *((us*)((r)+0x2E))
#define DPMI_SS(r)   *((us*)((r)+0x30))

#define DPMI_RM_ASYNC_STACK_PARAS 0x20
#define DPMI_PM_ASYNC_STACK_PARAS 0x100

extern void DPMI_pre_init (void);
extern void DPMI_init (void);
extern int  DPMI_alloc_dos (int nparas, us *sel, us *seg);
extern int  DPMI_resize_dos (int nparas, int sel);
extern void DPMI_free_dos (int sel);
extern int  DPMI_alloc (ui size, ui *rethandle, ui *retaddr);
extern int  DPMI_realloc (ui old_handle, ui new_size,
                          ui *new_handle, ui *new_addr);
extern int  DPMI_free (ui addr);
extern int  DPMI_create_alias (us sel);
extern int  DPMI_create_seg_alias (us seg);
extern int  DPMI_get_bios_selector (void);
extern void DPMI_get_rm_stack (us *seg, us *off);
extern int  DPMI_free_callback (ui i);
extern int  DPMI_vif (int typ);
extern int  DPMI_alloc_callback (us proc_sel, ui proc_off,
                                 us data_sel, ui data_off);
extern struct DPMI_callback  *DPMI_get_callback (ui i);
extern void DPMI_call_rm (int nint, int is_retf_frame,
                          int stack_words_to_copy, char *d);

#endif /* __DPMI_MOO__ */
