#ifndef __EIO_MOO__
#define __EIO_MOO__

#include <inc/adb.h>

#define EIO_MASK_B 1
#define EIO_MASK_W 2
#define EIO_MASK_D 4
#define EIO_MASK_BW 3
#define EIO_MASK_BWD 7

typedef ui (*EIO_read_handler)(int nport, int size);
typedef void (*EIO_write_handler)(int nport, int size, ui value);

extern void EIO_init (void);
extern void EIO_write (int nport, int size, ui value);
extern ui EIO_read (int nport, int size);
extern void EIO_register_read_handler (int nport, int smask,
                                       EIO_read_handler read_handler);
extern void EIO_register_write_handler (int nport, int smask,
                                        EIO_write_handler write_handler);

#define EIO_LOG_READ                                    \
  ldebug ("(nport=%#x, size=%d)\n", nport, size)

#define EIO_LOG_WRITE                           \
  ldebug ("(nport=%#x, size=%d, val=%#x)\n",    \
        nport, size, val)

#endif /* __EIO_MOO__ */
