#ifndef __LDT_MOO__
#define __LDT_MOO__

#include <inc/adb.h>

extern void          LDT_init (void);
extern int           LDT_alloc_selectors (int count);
extern int           LDT_create_alias (int selector);
extern int           LDT_create_system_alias (int is_code,
                                              unsigned long base_addr);
extern void          LDT_free_selector (int selector);
extern void          LDT_set_selector_base (int selector, unsigned long base);
extern void          LDT_set_selector_limit (int selector, unsigned int limit);
extern unsigned long LDT_get_selector_base (int selector);
extern unsigned int  LDT_get_selector_limit (int selector);
extern void          LDT_get_selector_descriptor (int selector, void *buf);
extern void          LDT_set_selector_descriptor (int selector, void *buf);
extern void          LDT_set_selector_access_rights (int selector, int ar);
extern unsigned int  LDT_get_selector_access_rights (int selector);
extern void          LDT_make_selector_permanent (int selector);
extern void          LDT_make_selector_immutable (int selector);
extern int           LDT_is_selector_big (int selector);

#endif /* __LDT_MOO__ */
