/* -*- mode: c -*- */

#define xglue__(x,y) turtle_ ## x ## y
#define glue__(x,y) xglue__(x,y)

#if SIZE == 8
#define D_TYPE uint8_t
#elif SIZE == 16
#define D_TYPE uint16_t
#elif SIZE == 32
#define D_TYPE uint32_t
#elif SIZE == 64
#define D_TYPE uint64_t
#else
#error Bad SIZE
#endif

D_TYPE glue__(read_flat_mem, SIZE) AP1__(uint32_t addr)
{
  if (IS_MEM_VGA (env, addr)) {
    HOT (env);
    return glue__(read_vga_mem, SIZE) (addr);
  }
  else
    return *(D_TYPE *) addr;
}

void glue__(write_flat_mem, SIZE) AP2__(uint32_t addr, D_TYPE val)
{
  if (IS_MEM_VGA (env, addr)) {
    HOT (env);
    glue__(write_vga_mem, SIZE) (addr, val);
  }
  else
    *(D_TYPE *) addr = val;
}

D_TYPE glue__(read_mem, SIZE) AP1__(uint32_t ea)
{
  uint32_t addr;

  addr = (uint32_t) env->segs[env->seg].base + ea;

  if (IS_MEM_VGA (env, addr)) {
    HOT (env);
    return glue__(read_vga_mem, SIZE) (addr);
  }
  else
    return *(D_TYPE *) addr;
}

D_TYPE glue__(read_seg_mem, SIZE) AP2__(int seg, uint32_t ea)
{
  uint32_t addr;

  addr = (uint32_t) env->segs[seg].base + ea;

  if (IS_MEM_VGA (env, addr)) {
    HOT (env);
    return glue__(read_vga_mem, SIZE) (addr);
  }
  else
    return *(D_TYPE *) addr;
}

void glue__(write_mem, SIZE) AP2__(uint32_t ea, D_TYPE val)
{
  uint32_t addr;

  addr = (uint32_t) env->segs[env->seg].base + ea;
  if (IS_MEM_VGA (env, addr)) {
    HOT (env);
    glue__(write_vga_mem, SIZE) (addr, val);
  }
  else
    *(D_TYPE *) addr = val;
}

void glue__(write_seg_mem, SIZE) AP3__(int seg, uint32_t ea, D_TYPE val)
{
  uint32_t addr;

  addr = (uint32_t) env->segs[seg].base + ea;
  if (IS_MEM_VGA (env, addr)) {
    HOT (env);
    glue__(write_vga_mem, SIZE) (addr, val);
  }
  else
    *(D_TYPE *) addr = val;
}

#undef D_TYPE
#undef glue__
#undef xglue__
