#include <string.h>

#include <inc/sou.h>
#include <inc/dma.h>
#include <inc/gus.h>
#include <inc/log.h>
#include <inc/mup.h>
#include <inc/aud.h>
#include <inc/sb16.h>

#define LOG_PREFIX "AUD"
static int log_level;

static audemu_e emu;

void SOU_run ()
{
  switch (emu) {
    case AUD_EMU_GUS:
      GUS_run ();
      break;

    case AUD_EMU_SB16:
      DMA_run ();
      SB16_run ();
      break;

    case AUD_EMU_NONE:
      break;
  }
}

void SOU_init ()
{
  log_level = MUP_get_log_level ("sou");
  emu = AUD_get_emu_type ();

  switch (emu) {
    case AUD_EMU_GUS:
      linfo ("using GUS\n");
      GUS_init ();
      break;

    case AUD_EMU_SB16:
      linfo ("using SB16\n");
      SB16_init ();
      break;

    case AUD_EMU_NONE:
      break;
  }
}
