/*
 * Portions (C) Glenn 'Gaffer' Fidler
 */

#include <stdio.h>
#include <unistd.h>

#include "structs.h"

void hook_vbe (struct VBEINFO *info)
{
}

void hook_mode (int nmode, struct MODEINFO *info)
{
}

int main (int argc, char **argv)
{
  FILE *f;
  struct VBEINFO vbe_info;
  struct MODEINFO mode_info;
  int nmode;
  int i;

  if (argc != 2) {
    fprintf (stderr, "usage: readmodes dir\n");
    return 1;
  }

  chdir (argv[1]);

  f = fopen ("info.vbe", "rb");
  fread (&vbe_info, 1, sizeof (vbe_info), f);
  fclose (f);

  hook_vbe (&vbe_info);

  f = fopen ("modes.vbe", "rb");
  for (i = 0; i < 0x200; i++) {
    fread (&nmode, 4, 1, f);
    if (nmode != -1) {
      fread (&mode_info, 1, sizeof (mode_info), f);
      hook_mode (nmode, &mode_info);
    }
  }
  fclose (f);
  return 0;
}
